/*----------------------------------------
  Definitionen fuer das 
  Hitachi HD44780 - LCD-Display
  (c) 2004 E.Hermanns
  ----------------------------------------*/

#ifndef _HD44780_
#define _HD44780_

# define HD_CMD			0
# define HD_DATA			1

# define HD_FUNCTION_SET 	0x20 /* Setzt die Datenbreite, Zeilenanzahl */
# define HD_CLS  	  	0x01 /* Display loeschen */
# define HD_HOME         	0x02 /* Cursor an Adresse 0 im Display  */
# define HD_SET_DD_ADR   	0x80 /* DD-Adresse setzen */

# define HD_ENTRY      		0x04 /* Setzt die Cursor-Richtung */
# define HD_INCREMENT  		0x02
# define HD_DECREMENT  		0x00

# define HD_CONTROL      	0x08 /* Setzt   Display  ON/ OFF */
# define HD_DISPLAY_ON   	0x04 /*         Cursor   ON/ OFF */
# define HD_DISPLAY_OFF  	0x00 /*         BLINK    ON/ OFF */
# define HD_CURSOR_ON    	0x02
# define HD_CURSOR_OFF   	0x00
# define HD_BLINK        	0x01
# define HD_NO_BLINK     	0x00

# define HD_8BIT        		0x10 /* 8-bit Datenbus                      */
# define HD_4BIT        		0x00 /* 4-bit Datenbus                      */
# define HD_2LINE       		0x08 /* zweizeiliges Display                */
# define HD_1LINE       		0x00 /* einzeiliges Display                 */ 
# define HD_10DOTS      		0x04 /* 5*10 dots Auflsung, je nach Displaytyp */
# define HD_7DOTS       		0x00 /* 5*7  dots */

#endif





