#ifdef LCD_PUTSTR
/*-----------------------------------
  ASCII-Z String auf LCD ausgeben
  -----------------------------------*/
void LcdPutstr(const char *str)
{
  while(*str)
    {
      LcdPutch(*str, HD_DATA);
      str++;
    }
} // LcdPutstr
#endif

#ifdef LCD_PUTSTR_P
/*-----------------------------------
  ASCII-Z String aus ROM ausgeben
  -----------------------------------*/
void LcdPutstr_P(PGM_P str)
{
  char Ch;
#ifdef AVR_STUDIO_DEBUG
  char Display[MY_DISP_WIDTH+1];
  strcpy_P (Display, str, );
  return;
#endif
  
  while( (Ch = pgm_read_byte(str)) )
    {
      LcdPutch(Ch, HD_DATA);
      str++;
    }
} // LcdPutstr_P
#endif


/*===========================================================================
  Diese Variante der Stoppuhr (mit einem long) braucht im worst case 8 Mal (!!)
  so lange wie die Variante mit Std/Min/Sec/Hun/Tsn in Einzelvariablen.
  Das sind im schlechtesten Fall etwa 1500us, also indiskutabel.
  ===========================================================================*/

/*-----------------------------------
  Die Stoppuhr ... (dauert zu lange)
  -----------------------------------*/
void StIncTime(void)
{
  /*----------------------------------------------------------------------
    Aufbau der Zeit-Struktur:

    unsigned long StTsn[11]; enthlt die gezhlten tausendstel Sekunden.
    knapp 50 Tage Laufzeit, ca. 1193 Stunden.
    Fuer die Stoppuhr-Funktion werden 10 Array-Elemente verwendet, 
    [0] = die aktuelle Zeit, [1]-[9] sind die Zwischenzeiten. 
    Ab Element [11] werden andere Zeiten gespeichert (z.B. DCF77)
    ----------------------------------------------------------------------*/		

  Bits.StTimeChanged = TRUE;

  StTsn[0]++;				     /* 1/1000 */
  // jetzt wirds brutal ...
  // zu brutal: fast 1500 us im Worst case. Vergisses.

  if (Bits.StShowTime == TRUE) { // Angenommener Wert: 1193:23:45,678 = (long) 4296225678
    uint8_t Rest, Wrk;
    Wrk = StTsn[0] % 1000;	// = '678'
    Wrk = (StTsn[0] >>8) / 125;	// test
    Rest = Wrk % 100;		// = '8'
    DspBuf[14] = Rest;	// Display: xx:xx:xx,xx8Sek
    if (!Rest){		// Wenn Rest=0, dann Ueberlauf 
      Wrk = Wrk / 10;		// = '67'
      Rest= Wrk % 10;		// = '7'
      DspBuf[13] = Wrk;	// Display: xx:xx:xx,x78 Sek
      if (!Wrk) {		// Wenn Rest=0, dann Ueberlauf 
	Rest = Wrk/10;	// = '6'
	DspBuf[12] = Rest;	// Display: xx:xx:xx,678 Sek
	if (!Rest) {	// Wenn Rest=0, dann Ueberlauf 
	  unsigned long Next; // Sekunden extrahieren
	  Next = (unsigned long) (StTsn[0] / 1000); // = 4296225
	  Wrk = (uint8_t) (Next % 60); // = 4295225 % 60 = 45 
	  Rest = Wrk%10;	// = '5'
	  DspBuf[10] = Rest;// Display: xx:xx:x5,678 Sek
	  if (!Rest) {	// Wenn Rest=0, dann Ueberlauf 
	    Rest = Wrk/10;	// = '4'
	    DspBuf[9] = Rest; // Display: xx:xx:45,678 Sek
	    if (!Rest) {	// Wenn Rest=0, dann Ueberlauf 
	      Next = Next/60; // = 4296225 / 60 = 71603
	      Wrk =  Next%60; // = 71603 % 60 = 23 
	      Rest = Wrk%10; // = '3';
	      DspBuf[7] = Rest; // Display: xx:x3:45,678 Sek
	      if (!Rest) {	// Wenn Rest=0, dann Ueberlauf 
		Rest = Wrk/10; // = '2'
		DspBuf[6] = Rest; // Display: xx:23:45,678 Sek
		if (!Rest) { // Wenn Rest=0, dann Ueberlauf 
		  Next =  Next%60; // = 71603/60 = 1193
		  Rest = (uint8_t)(Next%10); // = '3'
		  DspBuf[4] = Rest; // Display: x3:23:45,678 Sek
		  if (!Rest) { // Wenn Rest=0, dann Ueberlauf 
		    Wrk = (uint8_t)(Next/10); // = 1193/10 = 119
		    Rest = (uint8_t)(Wrk%10); // = '9'
		    DspBuf[3] = Rest; // Display: 93:23:45,678 
		    if (!Rest) { // Wenn Rest=0, dann Ueberlauf 
		      Wrk = Wrk/10; // = 119/10 = 11
		      Rest = (uint8_t)(Wrk%10); // = '1'
		      DspBuf[2] = Rest; // Display: 193:23:45,678 
		      if (!Rest) { // Wenn Rest=0, dann Ueberlauf 
			DspBuf[1] =(Wrk/10); // = 11/10 = 1, Display: 1193:23:45,678 
		      }
		    }
		  }
		}
	      }
	    }
	  }
	}
      }
    }
  }
} // StIncTime

